#!/usr/bin/env node

const fName = process.argv[2];

import { exec } from "child_process";
import { mkdir } from "fs";

const TASKS = [createFolder, openFolder, cloneRepo];

function execute(tasks) {
  return tasks.reduce((prev, task) => prev.then(task), Promise.resolve());
}

async function createFolder() {
  await Promise.resolve();
  mkdir(fName, (err) => {
    if (err) {
      return console.error(err);
    }
    //   console.log("Directory created successfully!");
  });
  console.log("Creating new directory");
}

async function openFolder() {
  await Promise.resolve();
  try {
    process.chdir(fName);
    console.log("Opening Folder");
  } catch (error) {
    console.log(error);
  }
}

async function cloneRepo() {
  await Promise.resolve();
  exec("git clone https://github.com/npm-pratik/html-js-css.git .");
  console.log("Cloning repo to directory");
}

execute(TASKS);
